<template>
  <div class="pt-3 addons">
    <h3 class="h4 text-center mb-3 mb-md-4 font-weight-bold text-dark">
      {{ $t('namebook.addons_title') }}
    </h3>
    <div
      v-if="items.length"
      class="d-flex flex-column flex-md-row justify-content-center"
    >
      <figure
        v-for="(item, index) in items"
        :key="'addon-' + index"
        class="addon"
      >
        <v-lazy-image
          :src-placeholder="item.cover | image | imageSize('small')"
          :src="item.cover | image"
          :alt="item.title"
          class="cover"
        />
        <figcaption>
          <div>
            <h4>{{ item.title }}</h4>
            <p class="d-none d-md-block">
              {{ item.excerpt }}
            </p>
          </div>
          <div class="price" v-html="getPrice(item.price)" />
        </figcaption>
        <img
          v-if="hasItem(item)"
          src="@/static/icons/minus.svg"
          alt="Minus"
          class="addon-icon"
          @click="remove(item)"
        >
        <img
          v-else
          src="@/static/icons/plus.svg"
          alt="Plus"
          class="addon-icon"
          @click="add(item)"
        >
      </figure>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

export default {
  name: 'NamebookAddons',
  computed: {
    ...mapGetters({
      items: 'book/getAddons',
      activeItems: 'book/getActiveAddons',
      currency: 'currency/getCurrency',
      currencies: 'currency/getCurrencies'
    })
  },
  methods: {
    ...mapActions({
      add: 'book/ADD_ACTIVE_ADDON',
      remove: 'book/REMOVE_ACTIVE_ADDON'
    }),
    hasItem (item) {
      return this.activeItems.filter(ob => ob.id === item.id).length
    },
    getPrice (price) {
      if (this.currency && this.currencies.length) {
        const currency = this.currencies.find(item => item.kod === this.currency)
        if (currency.kod !== 'KZT') {
          price = (price / parseFloat(currency.kurs)).toFixed(2)
        }
      }
      return this.$options.filters.price(price, this.currency || 'KZT')
    }
  }
}
</script>

<style lang="scss" scoped>
    //noinspection CssUnknownTarget
    @import "@/assets/scss/_variables.scss";
    @import "~bootstrap/scss/mixins/breakpoints";

    .addon {
        position: relative;
        margin: 0 1rem 2rem;
        max-width: 30%;
        background: #ffffff;
        text-align: center;
        color: #000000;
        box-shadow: 0 0 5px rgba(0, 0, 0, 0.15);
        font-size: 16px;
        padding: 1rem;
        -webkit-box-sizing: border-box;
        box-sizing: border-box;
        -webkit-transition: all 0.2s ease-out;
        transition: all 0.2s ease-out;
        @include media-breakpoint-down(sm) {
            max-width: 100%;
            width: 100%;
            padding: 0.5rem;
            margin: 0 0 1rem;
            display: flex;
            flex-direction: row;
            transform: scale(0.9);
        }

        * {
            -webkit-box-sizing: border-box;
            box-sizing: border-box;
            -webkit-transition: all 0.2s ease-out;
            transition: all 0.2s ease-out;
        }

        .cover {
            width: 100%;
            height: 10rem;
            object-fit: cover;
            vertical-align: top;
            position: relative;
            @include media-breakpoint-down(sm) {
                width: 30%;
                height: 7rem;
            }
        }

        figcaption {
            padding: 1rem;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: space-between;
            height: calc(100% - 10rem);
            @include media-breakpoint-down(sm) {
                text-align: left;
                align-items: flex-start;
            }
        }

        h4 {
            color: $dark;
            font-size: $font-size-base;
            margin-bottom: 0.25rem;
            font-weight: bold;
            text-transform: uppercase;
            @include media-breakpoint-down(sm) {
                font-size: $font-size-sm;
            }
        }

        p {
            margin: 0;
            color: $secondary;
        }

        .price {
            font-weight: 500;
            font-size: $font-size-base * 1.5;
            letter-spacing: 1px;
            color: $primary;
            @include media-breakpoint-down(sm) {
                font-size: $font-size-base;
            }
        }

        .addon-icon {
            position: absolute;
            bottom: 0;
            left: 50%;
            -webkit-transform: translate(-50%, 50%);
            transform: translate(-50%, 50%);
            width: 3rem;
            line-height: 3rem;
            text-align: center;
            border-radius: 50%;
            background-color: #ffffff;
            cursor: pointer;
            @include media-breakpoint-down(sm) {
                width: 1.5rem;
                line-height: 1.5rem;
                left: 65%;
            }
        }

        a {
            position: absolute;
            top: 0;
            bottom: 0;
            left: 0;
            right: 0;
            z-index: 1;
        }

        &:hover, &.hover {
            -webkit-transform: translateY(-5px);
            transform: translateY(-5px);
        }

        &:hover .addon-icon {
            background-color: $light;
            box-shadow: $box-shadow;
        }
    }

    @include media-breakpoint-down(sm) {
        .addons {
            overflow-y: auto;
            overflow-x: hidden;
            max-height: 60vh;
        }
    }
</style>
